'use strict';

function almoxarifadoLocalizacao(){
	var ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	var z = new ZeedhiAPIConstructor(browser, protractor);

	var self = this;

	this.abrir = function(){
		z.component.menu.open();
		z.component.menu.clickByPath(['Parametrização', 'Estoque', 'Almoxarifado/Localização']);
	},

	this.clickFiltro = function(){
		z.component.footer.clickRightActionByLabel('Filtro');
	},

	this.Voltar = function(){ //Função para clicar no botão voltar.
		z.component.footer.clickLeftActionByLabel('Voltar');
	},

	this.abrirMenu = function(){
        z.component.menu.open();
		z.component.menu.clickByPath(['Parametrização', 'Estoque', 'Almoxarifado/Localização']);
	},

	this.cadastrar = function(codigo, descricao, dispVenda, invarEntrada){
	   	z.component.footer.clickCenterActionByLabel("Adicionar"); //clicano botão "Adicionar" da tela.
      	z.field.fieldFunctions.fill("CDALMOXARIFE", codigo); //Adiciona valor ao campo código
      	z.field.fieldFunctions.fill("DSALMOXARIFE", descricao); //Clica no campo "Descriçõa de almoxarifado" e insere uma descrição.
      	z.field.selectNative.click("IDCHECK",dispVenda); //Clica no campo "Disponível para Venda", e seleciona a opção "Sim".
      	z.field.selectNative.click("IDALMOXINVAENTR",invarEntrada); // Clica no campo "Invariavél na entrada", e seleciona a opção "Não".
      	z.component.footer.clickRightActionByLabel("Salvar"); //Clica no botão de "Salvar" da tela.

	},

	this.filtroSelect = function(){
		z.component.floatingControl.open();
		z.component.floatingControl.selectAction("search");
		z.util.pressKey("ALMOXARIFADO TESTE");
		z.widget.grid.clickColumn('126826943027227155911703','0', '0');//Clicando no grid na primeira linha e coluna.
	},

	this.alterar = function(descricao, dispVenda, invarEntrada){
		self.filtroSelect();
      	z.component.footer.clickCenterActionByIcon("pencil"); //clicando botão "Editar" da tela.
		z.field.fieldFunctions.fill("DSALMOXARIFE", descricao); //Clica no campo "Descriçõa de almoxarifado" e insere uma descrição.
		z.field.selectNative.click("IDCHECK", dispVenda); //Clica no campo "Disponível para Venda", e seleciona a opção "Sim".
      	z.field.selectNative.click("IDALMOXINVAENTR", invarEntrada); // Clica no campo "Invariavél na entrada", e seleciona a opção "Não".
      	z.component.footer.clickRightActionByLabel("Salvar"); //Clica no botão de "Salvar" da tela.
		self.Voltar();//Clicar no botão "Voltar".
	},

	this.excluir = function(){
		z.widget.grid.clickColumn('126826943027227155911703','0', '0');//Clicando no grid na primeira linha e coluna.
		z.component.footer.clickCenterActionByIcon("trash"); //clicando botão "Excluir" da tela.
		z.component.alert.clickButton("Sim");
	},

	this.getGridText = function(gridid, row = 0, column = 0, checkBox = false){
		return z.widget.grid.getText(gridid, row, column, true);
	},

	this.gridHasText = function(gridid, column = 0, searchText, hasCheckBox = false){
		return element.all(by.repeater('rowIndex in filtered')).reduce(function(result, elem, index){
			if(result) return result;

			return self.getGridText(gridid, index, column, hasCheckBox).then(function(text){
				if(text == searchText) {
					return true;
				}
			});
		}).then(function(result){
			if(!result) return false;

			else
				return result;
		});
	}


}
module.exports = new almoxarifadoLocalizacao();